svn commit: r337840 - in head: cddl/usr.bin/ztest cddl/usr.bin/ztest/tests etc/mtree

Will Andrews will at FreeBSD.org
Wed Aug 15 13:05:06 UTC 2018


Author: will
Date: Wed Aug 15 13:05:04 2018
New Revision: 337840
URL: https://svnweb.freebsd.org/changeset/base/337840

Log:
  zfs: add ztest to the kyua test suite.
  
  This program is currently failing, and has been for >6 months on HEAD.
  Ideally, this should be run 24x7 in CI, to discover hard-to-find bugs that
  only manifest with concurrent i/o.
  
  Requested by:	lwhsu, mmacy

Added:
  head/cddl/usr.bin/ztest/tests/
  head/cddl/usr.bin/ztest/tests/Makefile   (contents, props changed)
  head/cddl/usr.bin/ztest/tests/ztest.sh   (contents, props changed)
Modified:
  head/cddl/usr.bin/ztest/Makefile
  head/etc/mtree/BSD.tests.dist

Modified: head/cddl/usr.bin/ztest/Makefile
==============================================================================
--- head/cddl/usr.bin/ztest/Makefile	Wed Aug 15 13:03:01 2018	(r337839)
+++ head/cddl/usr.bin/ztest/Makefile	Wed Aug 15 13:05:04 2018	(r337840)
@@ -25,4 +25,7 @@ CSTD=	c99
 # it without debugging.
 CFLAGS+= -g -DDEBUG=1 -Wno-format
 
+HAS_TESTS=
+SUBDIR.${MK_TESTS}+= tests
+
 .include <bsd.prog.mk>

Added: head/cddl/usr.bin/ztest/tests/Makefile
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/cddl/usr.bin/ztest/tests/Makefile	Wed Aug 15 13:05:04 2018	(r337840)
@@ -0,0 +1,7 @@
+# $FreeBSD$
+
+.include <bsd.own.mk>
+
+ATF_TESTS_SH+= ztest
+
+.include <bsd.test.mk>

Added: head/cddl/usr.bin/ztest/tests/ztest.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ head/cddl/usr.bin/ztest/tests/ztest.sh	Wed Aug 15 13:05:04 2018	(r337840)
@@ -0,0 +1,52 @@
+#
+# Test Case: ztest
+# $FreeBSD$
+#
+atf_test_case ztest
+ztest_head()
+{
+	atf_set "descr" "Run ztest"
+	atf_set "timeout" 900
+	atf_set "require.config" "rt_long"
+}
+
+ztest_body()
+{
+	ARGS="-VVVVV -f ${TMPDIR:-/tmp}"
+	if atf_config_has ztest_extra_args; then
+		ARGS="${ARGS} $(atf_config_get ztest_extra_args)"
+	fi
+	ztest ${ARGS}
+	if [ $? != 0 ]; then
+		echo "failing"
+		save_ztest_artifacts
+		atf_fail "Testcase failed"
+	else
+		echo "passing"
+		atf_pass
+	fi
+}
+
+#
+# ATF Test Program Init Function
+#
+atf_init_test_cases()
+{
+	atf_add_test_case ztest
+}
+
+save_ztest_artifacts()
+{
+	# If artifacts_dir is defined, save test artifacts for
+	# post-mortem analysis
+	if atf_config_has artifacts_dir; then
+		TC_ARTIFACTS_DIR=`atf_config_get artifacts_dir`/cddl/usr.bin/ztest/$(atf_get ident)
+		mkdir -p $TC_ARTIFACTS_DIR
+		TC_CORE_DIR=/var/crash
+		if atf_config_has core_dir; then
+			TC_CORE_DIR=`atf_config_get core_dir`
+		fi
+		mv *ztest*.core* $TC_ARTIFACTS_DIR || true
+		mv ${TC_CORE_DIR}/*ztest*.core* $TC_ARTIFACTS_DIR || true
+	fi
+}

Modified: head/etc/mtree/BSD.tests.dist
==============================================================================
--- head/etc/mtree/BSD.tests.dist	Wed Aug 15 13:03:01 2018	(r337839)
+++ head/etc/mtree/BSD.tests.dist	Wed Aug 15 13:05:04 2018	(r337840)
@@ -67,6 +67,8 @@
         usr.bin
             ctfconvert
             ..
+            ztest
+            ..
         ..
         usr.sbin
             dtrace


More information about the svn-src-head mailing list